/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2010 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

#pragma once
#include "Platform.h"

namespace SLK
{


class SerilynExport Map2D
{
public:
	Map2D(void);
	virtual ~Map2D(void);

	//Gets whether or not this tile is walkable
	virtual bool canWalk(int x, int y) = 0;
	//Gets the cost of walking on this tile. Should return 0 if this tile is not walkable.
	virtual float getCost(int x, int y) = 0;

	//Returns true only if the unit can walk between those points (implement for early out);
	virtual bool canWalkBetween(int x1, int y1, int x2, int y2){return true;};

	virtual int getXLength() = 0;
};


}