/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2010 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

#include "StdAfx.h"

#pragma once

namespace SLK
{

//Automatic singleton from "Game Programming Gems" pg 38
template<typename T> 
class Singleton
{
public:
	Singleton()
	{
		assert(!m_singleton);
		int offset = (int)(T*)1-(int)(Singleton<T>*)(T*)1;
		m_singleton = (T*)((int)this+offset);
	}

	virtual ~Singleton(void)
	{
		assert(m_singleton);
		m_singleton = 0;
	}

	static T& getSingleton()
	{
		assert(m_singleton); 
		return (*m_singleton);
	}

	static T* getSingletonPtr()
	{
		return m_singleton;
	}
protected:
	static T* m_singleton;
};

template<typename T> T* Singleton <T>::m_singleton = 0;

}