/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2010 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

#pragma once


#include "Platform.h"
#include "OgreOggSound.h"

namespace SLK
{

class SerilynExport SoundManager
{
public:
	SoundManager(void);
	virtual ~SoundManager(void);

	void playSound(std::string file,bool loop);

	//Creates a 3D sound
	OgreOggSound::OgreOggISound *createSound(const std::string& name,const std::string& file, bool stream = false, bool loop = false, bool preBuffer=false);
	
	//Creates a sound with 3D disabled
	OgreOggSound::OgreOggISound *createCameraSound(const std::string& name,const std::string& file, bool stream = false, bool loop = false, bool preBuffer=false);

	void update(float deltaTime);
private:
	OgreOggSound::OgreOggSoundManager *m_soundManager;
	static unsigned long m_nameCtr;
};

}
