/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2010 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

#include "StdAfx.h"
#include "Collision.h"


namespace SLK
{

Collision::Collision(void)
{
}

Collision::~Collision(void)
{
}

Ogre::Vector2 Collision::CollideCircleLine(Ogre::Vector2 circlePos, float radius, Ogre::Vector2 lineStart, Ogre::Vector2 lineEnd)
{
	Ogre::Vector2 dir = lineEnd - lineStart;
	Ogre::Vector2 diff = circlePos - lineStart;
	float t = diff.dotProduct(dir) / dir.dotProduct(dir);
	if(t < 0)
		t = 0;
	if(t > 1)
		t = 1;
	Ogre::Vector2 closest = lineStart + t * dir;
	Ogre::Vector2 normal = circlePos - closest;
	float distSquared = normal.dotProduct(normal);

	if(distSquared > radius * radius)
		return circlePos;

	//Scoot the circle back
	normal.normalise();
	float dist = Ogre::Math::Sqrt(distSquared);
	return circlePos - (-normal * (radius - dist));
}

}