#include "StdAfx.h"
#include "GeometryMaker.h"
#include "Application.h"

namespace SLK
{

GeometryMaker::GeometryMaker(void)
{
}

GeometryMaker::~GeometryMaker(void)
{
}

Ogre::ManualObject *GeometryMaker::makeSphere(std::string name, float radius, int slices, int stacks, std::string material)
{
	Ogre::Vector3 pos(0,radius,0);

	Ogre::Vector3 stackPtr(0,radius,0);
	Ogre::Matrix3 stackRotate;
	stackRotate.FromAxisAngle(Ogre::Vector3(0,0,1), Ogre::Radian(Ogre::Math::PI/stacks));
	Ogre::Matrix3 sliceRotate;
	sliceRotate.FromAxisAngle(Ogre::Vector3(0,1,0), Ogre::Radian(2*Ogre::Math::PI/slices));
	

	Ogre::SceneManager *sceneManager = SLK::Application::getSingletonPtr()->getSceneManager();
	Ogre::ManualObject *sphere = sceneManager->createManualObject(name);
	sphere->setDynamic(false);
	sphere->begin(material);

	Ogre::Vector3 drawPtr;
	Ogre::Vector3 drawPtrNext;

	int vertPtr = 0;
	int lastVertPtr = -slices;
	for(int stack=0; stack<stacks; stack++)
	{
		drawPtr = stackPtr;
		for(int slice=0; slice<slices; slice++)
		{
			sphere->position(drawPtr);
			sphere->normal(drawPtr.normalisedCopy());

			drawPtr = drawPtr * sliceRotate;

			if(stack>0 && slice>0)
			{//backwards winding...
				sphere->index(lastVertPtr - 1);
				sphere->index(vertPtr - 0);
				sphere->index(lastVertPtr - 0);
				sphere->index(lastVertPtr - 1);
				sphere->index(vertPtr - 1);
				sphere->index(vertPtr - 0);
			}
			vertPtr+=1;
			lastVertPtr+=1;
		}

		stackPtr = stackPtr * stackRotate;
	}

	sphere->end();
	
	return sphere;
}


}