/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2010 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

#include "StdAfx.h"

#include "Sequencer.h"
#include "DBStatement.h"
#include "DBResultSet.h"
#include "Database.h"

namespace SLK
{

Sequencer::Sequencer(std::string tableName, std::string idRow, SLK::Database *database):
	m_maxNum(0),
	m_tableName(tableName),
	m_idRow(idRow),
	m_database(database)
{
	if(database->tableExists(tableName))
	{
		std::stringstream maxQuery;
		maxQuery << "SELECT max(" << idRow << ") as MaxVal FROM " << tableName << ";";
		SLK::DBStatement statement(database);
		SLK::DBResultSet results;
		statement.prepare(maxQuery.str());
		statement.run(&results);

		results.GetRow(0)->Get("MaxVal",m_maxNum);
	}
}

Sequencer::~Sequencer(void)
{
}

int Sequencer::getNext()
{
	m_maxNum++;
	return m_maxNum;
	//TODO: If table is full try to find a number that fits.
}

}
