/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2010 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

#include "StdAfx.h"

#include "WindowToggler.h"
#include "UIManager.h"

namespace SLK
{

WindowToggler::WindowToggler(CEGUI::Window* screen):
	m_showing(false),
	m_screen(screen)
{
}

WindowToggler::~WindowToggler(void)
{
}

bool WindowToggler::toggleScreen(EventArgs &args)
{
	HotkeyEventArgs &keyArgs = dynamic_cast<HotkeyEventArgs&>(args);
	if(keyArgs.state == HotkeyEventArgs::Down)
	{
		if(!m_showing)
			m_screen->show();
		else
			m_screen->hide();

		m_showing = !m_showing;
	}

	return true;
}

bool WindowToggler::toggleScreen(bool status)
{
	if(status)
	{
		m_screen->show();
		m_screen->activate();
	}
	else
		m_screen->hide();

	m_showing = status;

	return true;
}

}